#include <arpschuino.h>
#include <ESPAsyncWebServer.h>
#include <SPIFFS.h>
#include <WiFiAP.h>
//#include <dmx.h> // https://github.com/luksal/ESP32-DMX-RX
#include "arp_server.h"
#include <Preferences.h>
#include "Port.h"
#include <string>
#include <iostream>
#include "_wifi.h"
#include <IPaddress.h>
//#include <iostream>
//using namespace std ;

extern Port portA;  //creation des objets port
extern Port portB;

Preferences preferences;

AsyncWebServer server(80);

extern int address;
extern uint8_t universe;
extern uint8_t signal_mode;

extern bool checkupdateFlag;
extern String new_version;
extern String update_status;


void checkAndWriteString(String keyWord,AsyncWebServerRequest *request,uint8_t page=0,String PORT="a");
void checkAndWriteUChar(String keyWord,AsyncWebServerRequest *request,uint8_t page=0,String PORT="a");
void checkAndWriteUInt(String keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT="a");
void checkAndWriteBool(String keyWord,AsyncWebServerRequest *request,uint8_t page=0,String PORT="a");
void checkAndWriteFloat(String keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT);

uint8_t checkAndLoadUChar(const char * keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT,uint8_t defaultVal);
uint16_t checkAndLoadUInt(const char * keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT,uint16_t defaultVal);
bool checkAndLoadBool(const char * keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT,bool defaultVal);
float checkAndLoadFloat(const char * keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT,float defaultVal);

void all_request()
{
  Serial.print("all_request() running on core ");
  Serial.println(xPortGetCoreID());
////////////////////charger les fichiers depuis le SPIIFS///////////////////////
  server.on("/", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/index.html", "text/html");
  });

  server.on("/inputs.html", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/inputs.html", "text/html");
  });  
 
  server.on("/ports.html", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/ports.html", "text/html");
  });  

  server.on("/divers.html", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/divers.html", "text/html");
  });  

  server.on("/style32_1.css", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/style32_1.css", "text/css");
  });  
 
  server.on("/script.js", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/script.js", "text/javascript");
  });

  server.on("/ports.js", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/ports.js", "text/javascript");
  });

  server.on("/OCRAEXT.TTF", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/OCRAEXT.TTF", "font/ttf");
  }); 

  server.on("/favicon.ico", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/favicon.png", "image/png");
  });

    server.on("/NWconfig.json", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/NWconfig.json", "text/json");
  });
//_________________________page network_______________________________

  server.on("/MAC_address", HTTP_GET, [](AsyncWebServerRequest *request) //charger MAcaddress
  {
    String Sdata = String(WiFi.macAddress());
    request->send(200, "text/plain", Sdata);
  }); 

  server.on("/currentIP", HTTP_GET, [](AsyncWebServerRequest *request) //charger currentIP
  {
    String Sdata="192.168.4.1";
    if(WiFi.status() == WL_CONNECTED)
      Sdata = WiFi.localIP().toString();
    //Serial.print("current IP : ");Serial.println(Sdata);
    request->send(200, "text/plain", Sdata);
  });   

//_________________________page inputs_______________________________

  server.on("/DMX_address", HTTP_GET, [](AsyncWebServerRequest *request) //charger DMX address
  {
    uint16_t temp = preferences.getUInt("DMX_address", 1);
    request->send(200, "text/plain", String(temp));
  });

  server.on("/universe", HTTP_GET, [](AsyncWebServerRequest *request)//charger univers artnet
  {
    uint8_t temp = preferences.getUChar("universe", 0); //String(universe);
    request->send(200, "text/plain",String(temp));//Sdata);
  });



/////////////////////////////////reboot////////////////////////////
  server.on("/reboot", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    //request->send(204);
    Serial.println("arpschuino32 will reboot");
    request->send(200, "text/plain", "arpschuino32 is rebooting !");
    delay(1000);
    ESP.restart();
  }); 
  //____________________________________________________________________
  //_________________________page outputs_______________________________// 


  /////////////////////////////////set///////////////////////////////////////////

  ////////////////////////////////////////////////////////////////////////////////////////  
//______________________________________divers_______________________________//

  server.on("/get_update_status", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(200, "text/plain", update_status);
  });

  server.on("/led_on", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    digitalWrite(0, HIGH);
    request->send(200);
  });

  server.on("/led_off", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    digitalWrite(0, LOW);
    request->send(200);
  });  


////////////////////////////////////////global////////////////////////////////////////////////////

  server.on("/get_request", HTTP_POST, [](AsyncWebServerRequest *request) {//recoit de requetes et renvoie les valeurs
    Serial.println();
    Serial.println("get_request");
    //AsyncWebServerResponse *response = request->beginResponse(200);
    String Sdata;//////////////////////////attention!!
    if(request->hasParam("PAGE", true))//page : 0 index, 1 input, 2 output, 3 divers
    {
      String message = request->getParam("PAGE", true)->value();//VAL0, la page
      uint8_t page = message.toInt();
      Serial.print("page ");Serial.println(message);

      switch(page)
      {
        case 0:{//index
          if(request->hasParam("AP_ssid", true)){
            Sdata= preferences.getString("AP_ssid","new_arpschuino32");
          }
          else if(request->hasParam("AP_pass", true)){
            Sdata= preferences.getString("AP_pass", "12345678");
          }
          else if(request->hasParam("hide_SSID", true)){
            Sdata= preferences.getBool("hide_SSID", false);
          }
          else if(request->hasParam("NW_ssid", true)){
            Sdata= preferences.getString("NW_ssid", "***");
          }
          else if(request->hasParam("NW_pass", true)){
            Sdata= preferences.getString("NW_pass", "***");
          }
          else if(request->hasParam("NW_ssid2", true)){
            Sdata= preferences.getString("NW_ssid2", "rescue");
          }
          else if(request->hasParam("NW_pass2", true)){
            Sdata= preferences.getString("NW_pass2", "arpschuino");
          }
          else if(request->hasParam("NW_timeout", true)){
            Sdata= preferences.getUChar("NW_timeout", 20);
          }
          else if(request->hasParam("hostname", true)){
            Sdata= preferences.getString("hostname", "arpschuino32");
          }          
          else if(request->hasParam("mode_static", true)){
            Sdata= preferences.getBool("mode_static", false);
          }
          else if(request->hasParam("fixIP", true)){
            Sdata= preferences.getString("fixIP", "192.168.1.32");
          }
          else if(request->hasParam("fixGateway", true)){
            Sdata= preferences.getString("fixGateway", "192.168.1.1");
          }
          else if(request->hasParam("fixSubnet", true)){
            Sdata= preferences.getString("fixSubnet", "255.255.255.0");
          }
          else if(request->hasParam("2SSID", true)){
            Sdata= preferences.getBool("2SSID", true);
          }          
          break;
        }
        case 1:{//input
          if(request->hasParam("signal_mode", true))/////le mode //0=pwm 1=onoff 2=servo
          {
            //uint8_t MODE= 0;
            //Sdata= preferences.getUChar("signal_mode", 0);
            uint8_t MODE = checkAndLoadUChar("signal_mode",request,1,"",0);

            switch(MODE)
            {
              case 0: { 
                Sdata = "DMX or Artnet IN";
                break;
              } 
              case 1:  {  
                Sdata = "DMX IN";   
                break;
              }
              case 2:  { //servo
                Sdata = "Artnet IN";
                break;               
              }
              case 3:  {  
                Sdata = "DMX IN > Artnet OUT";   
                break;
              }
              case 4:  {  
                Sdata = "Artnet IN > DMX OUT";   
                break;
              }              
            }    
          }
          //break;
        }
        case 2:{//port
          String PORT;
          if(request->hasParam("PORT", true))/////VAL1, le port
          {
            PORT = request->getParam("PORT", true)->value();
            Serial.print("port ");Serial.print(PORT); Serial.print(" ");
          }
          
          if(request->hasParam("MODE", true))/////le mode //0=pwm 1=onoff 2=servo
          {
            uint8_t MODE= 0;
            if (PORT=="A")
              MODE= portA.load("mode",MODE);
            else if(PORT=="B")
              MODE= portB.load("mode",MODE);

            switch(MODE)
            {
              case 0: {  //pwm
                Sdata = "pwm";
                break;
              } 
              case 1:  {  //on/off
                Sdata = "on/off";   
                break;
              }
              case 2:  { //servo
                Sdata = "servo";
                break;               
              }
              case 3:  {  
                Sdata = "stepper";   
                break;
              }
              case 4:  {  
                Sdata = "CCmotor";   
                break;
              }              
              //////////////////////////////
              case 254:  { 
                Sdata = "custom";
                break;               
              }              
              default:
                Sdata = "inactive";
            }    
          }
          else
          {
            if(request->hasParam("NbDmxChannels", true))/////
            {
              if(PORT=="A")
                Sdata=portA.getNbDmxChannels();
              else if(PORT=="B")
                Sdata=portB.getNbDmxChannels();
            }            
            if(request->hasParam("dmxRes", true))/////resolution DMX
            {
              Sdata=checkAndLoadBool("dmxRes",request,2,PORT,0);
            }
            else if(request->hasParam("PWM_resolution", true))/////resolution PWM
            {
              Sdata=checkAndLoadUChar("PWM_resolution",request,2,PORT,14);
            }
            else if(request->hasParam("pwmCurve", true))/////curve
            {
              Sdata=checkAndLoadBool("pwmCurve",request,2,PORT,0);
            }            
            else if(request->hasParam("pwmFreq", true))
            {
              uint32_t next_freq = 40000000;
              uint8_t next_resol = 14;
              if (PORT=="A"){
                next_resol = portA.load("PWM_resolution",next_resol);
              }
              else if (PORT=="B"){
                next_resol = portB.load("PWM_resolution",next_resol);
              }
              for(int i=1;i<next_resol;i++){
                next_freq=next_freq/2;
              }
              Sdata = String(next_freq);
            }            
            else if(request->hasParam("trigger", true))
            {
              Sdata=checkAndLoadUChar("trigger",request,2,PORT,128);
            } 
            else if(request->hasParam("trig_percent", true))
            {
              //Serial.print("trig_percent : ");
              uint8_t trigger= 128;
              uint8_t percent = 0;
              if (PORT=="A"){
                trigger = portA.load("trigger",trigger);
              }
              else if (PORT=="B"){
                trigger = portB.load("trigger",trigger);
              }
              percent=trigger*100/255;
              //Serial.print("%");
              Sdata = String(percent);
            }            
            else if(request->hasParam("inverted", true))
            {
              Sdata=checkAndLoadBool("inverted",request,2,PORT,0);
            }
            else if(request->hasParam("angle", true))
            {
              Sdata=checkAndLoadUChar("angle",request,2,PORT,180);
            }
            else if(request->hasParam("detach", true))
            {
              Sdata=checkAndLoadBool("detach",request,2,PORT,0);
            } 
            // else if(request->hasParam("action", true))
            // {
            //     Sdata=checkAndLoadBool("action",request,2,PORT,0);
            // } 
            else if(request->hasParam("stepper", true))
            { 
              String stepperNum = request->getParam("stepper", true)->value(); 

              String str = stepperNum + "stpPerRevol";
              if(request->hasParam(str, true))//////////////////////////
              {
                  const char * key = str.c_str();
                  Sdata=checkAndLoadUInt(key,request,2,PORT,400);
              }
              str = stepperNum + "stpActive"; 
              if(request->hasParam(str, true))//////////////////////////
              {
                  const char * key = (str).c_str();
                  Sdata=checkAndLoadBool(key,request,2,PORT,true);
              } 
              str = stepperNum + "_rpm_min";                        
              if(request->hasParam((str), true))
              {
                  const char * key = (str).c_str();
                  Sdata=checkAndLoadUInt(key,request,2,PORT,6);
              } 
              str = stepperNum + "_rpm_max";
              if(request->hasParam(str, true))
              {
                  const char * key = (str).c_str();
                  Sdata=checkAndLoadUInt(key,request,2,PORT,200);
              } 
              str = stepperNum + "_revol";
              if(request->hasParam(str, true))
              {
                  const char * key = (str).c_str();
                  Sdata=checkAndLoadFloat(key,request,2,PORT,100);
              }
              //stpInverted
              str = stepperNum + "stpInverted";
              if(request->hasParam(str, true))
              {
                  const char * key = (str).c_str();
                  Sdata=checkAndLoadBool(key,request,2,PORT,false);
              }               
              str = stepperNum + "stpAction";
              if(request->hasParam(str, true))
              {
                  const char * key = (str).c_str();
                  Sdata=checkAndLoadBool(key,request,2,PORT,true);
              } 
              str = stepperNum + "stp_dmxRes";    
              if(request->hasParam(str, true))//     else if ???????????????????????????
              {
                  const char * key = (str).c_str();
                  Sdata=checkAndLoadBool(key,request,2,PORT,100);
              }                        
            }
            else if(request->hasParam("CCmotor", true)) 
            {
              String Num = request->getParam("CCmotor", true)->value(); 
              
              //CCInverted
              String str = Num + "CCInverted";
              if(request->hasParam(str, true))
              {
                  const char * key = (str).c_str();
                  Sdata=checkAndLoadBool(key,request,2,PORT,false);
              } 
              str = Num + "thresold";
              if(request->hasParam(str, true))//////////////////////////
              {
                  const char * key = str.c_str();
                  Sdata=checkAndLoadUChar(key,request,2,PORT,1);
              }
              String str_percent = Num + "thresold_percent";
              if(request->hasParam(str_percent, true))
              {
                Serial.print(Num);Serial.print("thresold ");
                uint8_t thresold= 1;
                uint8_t percent = 0;
                if (PORT=="A"){
                  thresold = portA.load(Num + "thresold",thresold);
                }
                else if (PORT=="B"){
                  thresold = portB.load(Num + "thresold",thresold);
                }
                percent=thresold*100/255;
                Serial.print("%");
                Sdata = String(percent);
              }                            
            }                                       
          }
          break;
        }
        case 3:{//divers
          if(request->hasParam("update", true))
          {
            Serial.print("update request ");
            new_version= request->getParam("version", true)->value();
            Serial.println(new_version);
            checkupdateFlag=true;

            //update_status="search if this version is available";
            Sdata = update_status;
          }
          break;
        }
      }
      Serial.print(" : ");
      Serial.println(Sdata);
    }  
    request->send(200, "text/plain", Sdata);
  });


  server.on("/set_request", HTTP_POST, [](AsyncWebServerRequest *request) {//recoit de requetes et enregistre les variables ds l'eeprom
    Serial.println("set_request");
    if(request->hasParam("PAGE", true))//page : 0 index, 1 input, 2 ports, 3 tools
    {
      String message0 = request->getParam("PAGE", true)->value();//VAL0, la page
      uint8_t page = message0.toInt();
      Serial.print("page ");Serial.println(message0);

      switch(page)
      {
        case 0:{//index
          checkAndWriteString("AP_ssid",request);
          checkAndWriteString("AP_pass",request);
          checkAndWriteBool("hide_SSID",request);
          checkAndWriteString("NW_ssid",request);
          checkAndWriteString("NW_pass",request);
          checkAndWriteBool("2SSID",request);
          checkAndWriteString("NW_ssid2",request);
          checkAndWriteString("NW_pass2",request);          

          checkAndWriteUChar("NW_timeout", request);
          checkAndWriteString("hostname",request);
          checkAndWriteBool("mode_static",request);
          checkAndWriteString("fixIP",request);
          checkAndWriteString("fixGateway",request);
          checkAndWriteString("fixSubnet",request);
          break;
        }
        case 1:{
          checkAndWriteUChar("signal_mode",request,1); 
          checkAndWriteUInt("DMX_address",request,1); 
          checkAndWriteUChar("universe",request,1);    
          break;
        }
        case 2:{//output (ports)
          String PORT;
          if(request->hasParam("PORT", true))/////VAL1, le port
          {
            PORT = request->getParam("PORT", true)->value();
            Serial.print("port ");Serial.print(PORT); Serial.print(" ");
          }
          checkAndWriteUChar("mode",request,2,PORT);
          checkAndWriteBool("dmxRes",request,2,PORT);
          checkAndWriteUChar("PWM_resolution",request,2,PORT);
          checkAndWriteBool("pwmCurve",request,2,PORT);
          checkAndWriteUChar("trigger",request,2,PORT);
          checkAndWriteBool("inverted",request,2,PORT);
          checkAndWriteUChar("angle",request,2,PORT);
          checkAndWriteBool("detach",request,2,PORT); 
          //checkAndWriteBool("action",request,2,PORT);
          if(request->hasParam("stepper", true))
          {
            String str = request->getParam("stepper", true)->value();
            Serial.print("STRstepperNum = ");Serial.println(str);
            checkAndWriteBool(str + "stpActive",request,2,PORT);
            checkAndWriteUInt(str + "stpPerRevol",request,2,PORT);
            checkAndWriteUInt(str + "_rpm_min",request,2,PORT);
            checkAndWriteUInt(str + "_rpm_max",request,2,PORT);
            checkAndWriteFloat(str + "_revol",request,2,PORT);
            checkAndWriteBool(str + "stpInverted",request,2,PORT);///////////////////////////////
            checkAndWriteBool(str + "stpAction",request,2,PORT);
            checkAndWriteBool(str + "stp_dmxRes",request,2,PORT);                 
          }
          if(request->hasParam("CCmotor", true))////////////////////////////////////////////////////////////////
          {
            String str = request->getParam("CCmotor", true)->value();
            checkAndWriteBool(str + "CCInverted",request,2,PORT);///////////////////////////////
            checkAndWriteUChar(str + "thresold",request,2,PORT);                
          }          
          break;
        }
        case 3:{//divers

          break;
        }
      }
    }
    request->send(204);
  });

////////////////////////////////////////////////////////////////////////////////////////////
  server.begin();
  Serial.println("Server active! ");  
  vTaskDelay(1);
}


void init_SPIFFS()
{
 if(!SPIFFS.begin())
  {
    Serial.println("SPIFFS error...");
    return;
  }
  File root = SPIFFS.open("/");
  File file = root.openNextFile();

  while(file)
  {
    Serial.print("File: ");
    Serial.println(file.name());
    file.close();
    file = root.openNextFile();
  }
  Serial.println("\n");
}

void init_preferences()
{

  preferences.begin("wifi_datas", false);

  address = preferences.getUInt("DMX_address", 1); 
  Serial.print("DMX address : ");
  Serial.println(address);  

  universe = preferences.getUChar("universe", 0); 
  Serial.print("artnet universe : ");
  Serial.println(universe); 

  signal_mode = preferences.getUChar("signal_mode", 0);
  Serial.print("signal mode : ");
  String SMODE;
  switch(signal_mode)
  {
    case 0: { 
      SMODE = "DMX or Artnet IN";
      break;
    } 
    case 1:  {  
      SMODE = "DMX IN";   
      break;
    }
    case 2:  { //servo
      SMODE = "Artnet IN";
      break;               
    }
    case 3:  {  
      SMODE = "DMX IN > Artnet OUT";   
      break;
    }
    case 4:  {  
      SMODE = "Artnet IN > DMX OUT";   
      break;
    }              
  }   
  Serial.println(SMODE); 
}


void checkAndWriteString(String keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT)
{
  if(request->hasParam(keyWord, true))
  {
    String message = request->getParam(keyWord, true)->value();
    if(message!="")
    { 
      const char * key = keyWord.c_str(); 
      if(page==0)
        preferences.putString(key,message);
        //writeJsonString(NWConfig,key,message);
      else if(page==2)
      {
        if (PORT=="A")
          portA.record(key,message);
        else if(PORT=="B")
          portB.record(key,message);        
      }      
      Serial.print("New ");
      Serial.print(keyWord);
      Serial.print(" : ");
      Serial.println(message);
    }
  }
}

void checkAndWriteUChar(String keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT)
{
  if(request->hasParam(keyWord, true))
  {
    String message = request->getParam(keyWord, true)->value();
    if(message!="")
    { 
      const char * key = keyWord.c_str(); 
      uint8_t temp = message.toInt();
      switch(page)
      {
       // case 0:      
          //writeJsonUchar(NWConfig,key,temp);
        //   preferences.putUChar(key, temp);
        //   break;
        case 1:  
          preferences.putUChar(key, temp);
          break;
        case 2:
          if (PORT=="A")
            portA.record(key,temp);
          else if(PORT=="B")
            portB.record(key,temp);
          break; 
        default :
          preferences.putUChar(key, temp);       
      }
      Serial.print("New ");
      Serial.print(keyWord);
      Serial.print(" : ");
      Serial.println(message);
    }
  }
}

void checkAndWriteUInt(String keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT)
{
  if(request->hasParam(keyWord, true))
  {
    String message = request->getParam(keyWord, true)->value();
    if(message!="")
    { 
      const char * key = keyWord.c_str(); 
      uint16_t temp = message.toInt();
      switch(page)
      {
        // case 0:      
        //   //writeJsonUchar(NWConfig,key,temp);
        //   break;
        // case 1:  
        //   //preferences.putUChar(key, temp);
        //   break;
        case 2:
          if (PORT=="A")
            portA.record(key,temp);
          else if(PORT=="B")
            portB.record(key,temp);
          break;
        default:
          preferences.putUInt(key, temp);        
      }
      Serial.print("New ");
      Serial.print(keyWord);
      Serial.print(" : ");
      Serial.println(message);
    }
  }
}

void checkAndWriteBool(String keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT)
{
  if(request->hasParam(keyWord, true))
  {
    String message = request->getParam(keyWord, true)->value();
    if(message!="")
    { 
      const char * key = keyWord.c_str();
      uint8_t temp;
      if(message=="true")
        temp=1;
      else if(message=="false")
        temp=0;
      else
        temp = message.toInt();
      // Serial.print("message : ");Serial.println(message);
      // Serial.print(", temp : ");Serial.println(temp);
      if(page==2)
      {
        
        if (PORT=="A")
          portA.record(key,temp);
        else if(PORT=="B")
          portB.record(key,temp);        
      }      
      else 
        preferences.putBool(key, temp);
        //writeJsonBool(NWConfig,key,temp);
        
      Serial.print(keyWord);
      Serial.print(" : ");
      Serial.println(temp);
    }
  }
}

void checkAndWriteFloat(String keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT)
{
  if(request->hasParam(keyWord, true))
  {
    String message = request->getParam(keyWord, true)->value();
    if(message!="")
    { 
      const char * key = keyWord.c_str(); 
      float temp = message.toFloat();
      switch(page)
      {
        // case 0:      
        //  // writeJsonUchar(NWConfig,key,temp);
        //   break;
        // case 1:  
        //   preferences.putFloat(key, temp);
        //   break;
        case 2:
          if (PORT=="A")
            portA.record(key,temp);
          else if(PORT=="B")
            portB.record(key,temp);
          break;
        default:
          preferences.putFloat(key, temp);        
      }
      Serial.print("New ");
      Serial.print(keyWord);
      Serial.print(" : ");
      Serial.println(message);
    }
  }
}
//////////////////////////////////////////////////////////////////////////////////
// uint8_t checkAndLoadUString(const char * keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT,uint8_t defaultVal)
// {
//   uint8_t val=defaultVal;
//     switch(page)
//     {
//       case 2:{
//         if (PORT=="A")
//           val= portA.load(keyWord,defaultVal);
//         else if(PORT=="B")
//           val= portB.load(keyWord,defaultVal);
//         break;
//       default:
//         val= preferences.getString(keyWord,defaultVal);             
//       }        
//     }
//     Serial.print(keyWord);
//     return val;
//   //}
// }


uint8_t checkAndLoadUChar(const char * keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT,uint8_t defaultVal)
{
  uint8_t val=defaultVal;
  // if(request->hasParam(keyWord, true))//if(request->hasParam("trigger", true))
  // {
    switch(page)
    {
      // case 0:          
      //     //writeJsonUchar(NWConfig,key,temp);
      //   break;
      // case 1:  
      //     //preferences.getUChar(key, temp);
      //   break;
      case 2:{
        if (PORT=="A")
          val= portA.load(keyWord,defaultVal);
        else if(PORT=="B")
          val= portB.load(keyWord,defaultVal);
        break;
      default:
        val= preferences.getUChar(keyWord,defaultVal);             
      }        
    }
    Serial.print(keyWord);
    // Serial.print(" : ");
    // Serial.println(val);
    return val;
  //}
}

uint16_t checkAndLoadUInt(const char * keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT,uint16_t defaultVal)
{
  uint16_t val=defaultVal;
    switch(page)
    {
      // case 0:          
      //     //writeJsonUchar(NWConfig,key,temp);
      //   break;
      // case 1:  
      //     //preferences.putUChar(key, temp);
      //   break;
      case 2:{
        if (PORT=="A")
          val= portA.load(keyWord,defaultVal);
        else if(PORT=="B")
          val= portB.load(keyWord,defaultVal);
        break;
      default:
         val = preferences.getUChar(keyWord,defaultVal); 
      }        
    }
    Serial.print(keyWord);
    return val;
}

bool checkAndLoadBool(const char * keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT,bool defaultVal)
{
  bool val=defaultVal;
  // if(request->hasParam(keyWord, true))
  // {
    switch(page)
    {
      // case 0:      
      //     //writeJsonUchar(NWConfig,key,temp);
      //   break;
      // case 1:  
      //     //preferences.putUChar(key, temp);
      //   break;
      case 2:{
        if (PORT=="A")
          val= portA.load(keyWord,defaultVal);
        else if(PORT=="B")
          val= portB.load(keyWord,defaultVal);
        break;
      default:
         val = preferences.getBool(keyWord,defaultVal);         
      }        
    }
    Serial.print(keyWord);
    // Serial.print(" : ");
    // Serial.println(val);
    return val;
  //}
}

float checkAndLoadFloat(const char * keyWord,AsyncWebServerRequest *request,uint8_t page,String PORT,float defaultVal)
{
  float val=defaultVal;
    switch(page)
    {
      // case 0:          
      //     //writeJsonUchar(NWConfig,key,temp);
      //   break;
      // case 1:  
      //     preferences.putFloat(keyWord, defaultVal);
      //   break;
      case 2:{
        if (PORT=="A"){
          val= portA.load(keyWord,defaultVal);
          }
        else if(PORT=="B")
          val= portB.load(keyWord,defaultVal);
        break;
      default:
        val = preferences.getFloat(keyWord,defaultVal);
      }        
    }
    Serial.print(keyWord);
    return val;
}


void record(const char * key,uint32_t val)
{
  preferences.putUInt(key, val);
}